import wget
import datetime as dt
import math
import os
import sys
import time
from multiprocessing import Process,Queue,Lock,Value

# https://my-devblog.tistory.com/18

#start_dt = dt.date(2014, 11, 22)
start_dt = dt.date(2020, 1, 1)
end_dt = dt.datetime.date(dt.datetime.now())
base_url = "https://s3-eu-west-1.amazonaws.com/public.bitmex.com/data/trade/{}.csv.gz"
out_path = os.path.dirname(os.path.abspath(__file__))
worker_cnt = 5 # worker process counts
wait_time = 2 # 2 second


def bar_custom(current, total, width=80):
  width = 30
  avail_dots = width - 2
  shaded_dots = int(math.floor(float(current) / total * avail_dots))
  percent_bar = '[' + '■' * shaded_dots + ' ' * (avail_dots - shaded_dots) + ']'
  progress = "%d%% %s [%d / %d]" % (current / total * 100, percent_bar, current, total)
  return progress

def do_work(q,l,v,w):
  if q.empty() or v.value >= w : return
  l.acquire()
  v.value = v.value + 1
  l.release()
  try:
    if q.empty(): 
      return
    u = q.get()
    print("START: {},pid={},v={}".format(u,os.getpid(),v.value))
    sys.stdout.flush()
    #wget.download(u, out=out_path, bar=bar_custom)
    wget.download(u, out=out_path)
  except:
    pass

  print("END: {},pid={},v={}".format(u,os.getpid(),v.value))
  sys.stdout.flush()

  l.acquire()
  v.value = v.value - 1
  l.release()


def main():
  days = end_dt - start_dt 
  print("days : ",days)
 
  down_urls = Queue()
  #for d in range(0,days.days-1):
  for d in range(0,days.days):
    day = start_dt + dt.timedelta(days=d)
    sday = day.strftime("%Y%m%d")
    if os.path.exists(os.path.join(out_path, "{}.csv.gz".format(sday))):
      continue
    down_urls.put(base_url.format(sday))

  v = Value('i',0)
  l = Lock()

  while not down_urls.empty():
    if v.value >= worker_cnt:
      time.sleep(wait_time)
      continue
    else:
      p = Process(target=do_work, args=(down_urls,l,v,worker_cnt))
      p.start()



if __name__=="__main__":
  main()
